
#import <appkit/appkit.h>

@interface RECView:View {

	id		bigView;
	id		bigWindow;
	id		infoPanel;
	id		parPanel;
	id		RECOButn;
	id 		RECLine;
	id		RECMatrix;
	id		RECPanel;

	id		sourceView;
	id		sourceWindow;

	id		phaseView;
	id		phaseWindow;
	id		solutionView;
	id		solutionWindow;
	id		asymptoticView;
	id		asymptoticWindow;
	id		stabilityView;
	id		stabilityWindow;

	id		browser;
	id		comment;

	id		bigBox;
	id		extBox;
	id		intBox;
	id		lilBox;

	id		execWin;
	id		RECValue;

	id		menuCopy;
	id		menuPrint;

	char		*filename;
	char		**filenames;

}

- ascii:sender;
- recMatrix:sender;

- loadRECPanel:sender;
- loadRECSource:sender;

- recompile:sender;
- run:sender;
- runPhase:sender;
- runSolution:sender;
- runRECLine:sender;
- setOption:sender;

- smartPrintBigWin:sender;
- openBigWin:sender;

- close:sender;
- open:sender;
- setFilename:(const char *)aFilename;
- save:sender;
- saveAs:sender;

- copyREC:sender;
- copySomeView:theView;

@end

/* end RECView.h */
