/*  PRUEBA.C	Programa de demostracion funciones de VIDEO.	*/
/*			19/09/90				*/
/*		Saturnino Julio De la Trinidad H.		*/

#include <stdio.h>
#include "videoh.h"   /*  Debera incluirse, para funciones de video. */

/* Definicion de algunas constantes  (ver VIDEOH.DOC) */
#define CGA_320	4
#define CGA_640 6
#define CO80	3
#define COLOR1	1
#define COLOR2	2


main(){

 int color, MaxX, MaxY, MaxColors, MaxPalette;
 int i, j, k, c, mode, opcion;

  videomode(CO80);
  videocursor(0, 3, 7);   videocattr(0, '*', COLOR1, 45);
  videocursor(0, 5, 10);  printf(" Elija un modo de video:");
  videocursor(0, 7, 12);  printf("1.- CGA 320X200 4 colores.");
  videocursor(0, 9, 12);  printf("2.- CGA 640X200 2 colores.");
  videocursor(0, 13, 7);  videocattr(0, '*', COLOR2, 45);
  videocursor(0, 5, 35);  opcion=getchar();
  switch(opcion){
	case '1': videomode(CGA_320);
		  break;
	case '2': videomode(CGA_640);
		  break;
        default: videomode(CO80);
 		 printf("Opcion NO valida , Pruebe de nuevo\n\n");
		 exit(1);
	}

  MaxY= 200;
  mode = videogmode();	/* Tomamos modo de video. */
  switch(mode){
      case CGA_320: MaxX= 320;
		    MaxColors= 4;
		    MaxPalette= 2;
		    break;
      case CGA_640: MaxX= 640;
		    MaxColors= 2;
		    MaxPalette= 1;
		    break;
      default:
		break;
      }

 for(i=0; i < 5*MaxColors; i++)
     Frame(i*2,i*2,MaxY-i*2, MaxX-i*2, i%MaxColors);

 for(k=0; k<MaxPalette; k++){
    videopalette(k);		/* Cambia el tipo de paleta. */
    delay(1500);
    }

 for( color=0; color < 8; color ++){
    videobackground(color);	/* Modifica el color de fondo. */
    delay(1500);
    }

  videomode(CO80);		/* Regresa a modo alfanumerico 80 X 25 */
}/* main */

Frame(int x1, int y1 ,int x2, int y2, int color)
{
 int i;
  for(i=x1; i<x2; i++){
     videodot(i, y1, color);
     videodot(i, y2, color);
     }
  for(i=y1; i<y2; i++){
    videodot(x1, i, color);
    videodot(x2, i, color);
    }
}