

;=======================================================================;
;  Creado por: Dr. Harold V. McIntosh			27-Apr-90	;
;  Modificado: Saturnino Julio De La Trinidad H.			;
;							31-Ago-90	;
;							09-Sep-91	;
;	   Departamento de Aplicacion de Microcomputadoras		;
;	Instituto de Ciencias de la Universidad Autonoma de Puebla	;
;=======================================================================;

include progseg.h		; Declaraciones de segmentos
 
		public	_videobackground, _videocmode
		public	_videomode, _videopalette, _videodot
		public	_videoputc, _videochar, _videocattr  
		public	_videoscroll, _videocursor, _videopage
		public	_videogchar, _videogcmode, _videogcols
		public	_videogcursor, _videogdot, _videogmode
		public	_videogpage, _videogpen



videom		proc	far

;========================================
;		videeobackground	;
;========================================
; Selecciona el color de fondo
_videobackground:
		push	si
		push	di
		push	bp
		mov	bp,sp
		mov	ah,0Bh		; Funcion 11
		mov	bh,0		; bh=0, para color de fondo 
		mov	bl,[bp+0Ah]	; color de fondo (0-15)
		int	10h		; Interrupcion de video, coloca el
					; color tomandolo de bx (modo CGA)
		pop	bp
		pop	di
		pop	si
		ret			; Return far

;========================================
;		_videocattr		;
;========================================
; Coloca caracter (al) y atributo (ah) en la posicion del cursor
_videocattr:
		push	si
		push	di
loc_9:
		push	bp
		mov	bp,sp
		mov	ah,9		; Funcion 9
		mov	bh,[bp+0Ah]	; Pagina (Valido para modo alfa)
		mov	al,[bp+0Ch]	; Caracter a escribir
		mov	bl,[bp+0Eh]	; Atributo del caracter(modo alfa.),
					; color(modo grafico)

		mov	cx,[bp+10h]	; Numero de caracteres a escribir.
		int	10h		; Interrupcion de video, escribe (cx)
					; caracteres (al) y atributo (ah)
		pop	bp
		pop	di
		pop	si
		ret			; Return far


;========================================
;		_videochar		;
;========================================
; Escribe el caracter (al) en la  posicion del cursor.
_videochar:
		push	si
		push	di
		push	bp
		mov	bp,sp
		mov	ah,0Ah		; Funcion 10
		mov	bh,[bp+0Ah]	; Pagina (modo alfanumerico)
		mov	al,[bp+0Ch]	; Caracter a escribir
		mov	cx,[bp+0Eh]	; Numero de caracteres a escribir
		int	10h		; Interrupcion de video,  escribe
					; el caracter en (al) apartir de la
					; posicion deedl cursor
		pop	bp
		pop	di
		pop	si
		ret				; Return far


;========================================
;		_videocmode		;
;========================================
; Coloca tipo de cursor.
_videocmode:
		push	si
		push	di
		push	bp
		mov	bp,sp
		mov	ah,1		; Funcion 01
		mov	ch,[bp+0Ah]	; Linea de inicio para el cursor
		mov	cl,[bp+0Ch]	; Fin de linea para cursor
		int	10h		; Interrupcion de video, inicializa 
					; el tamano del cursor.
		pop	bp
		pop	di
		pop	si
		ret				; Return far

;========================================
;		_videocursor		;
;========================================
; Coloca la posicion del cursor.
_videocursor:
		push	si
		push	di
		push	bp
		mov	bp,sp
		mov	dh,[bp+0Ch]	; Renglon
		mov	dl,[bp+0Eh]	; Columna
		mov	bh,[bp+0Ah]	; Numero de pagina (debe ser 0 para
					; modo grafico)
		mov	ah,2		; Funcion 2
		int	10h		; Interrupcion de video, posiciona
					; el cursor.
		pop	bp
		pop	di
		pop	si
		ret				; Return far

;========================================
;		_videodot		;
;========================================
; Coloca un pixel en la posicion indicada
_videodot:
		push	si
		push	di
		push	bp
		mov	bp,sp
		mov	ah,0Ch			; funcion 12
		mov	dx,[bp+0Ah]		; numero de renglon
		mov	cx,[bp+0Ch]		; numero de columna
		mov	al,[bp+0Eh]		; color del pixel
		int	10h			; interrupcion de video

		pop	bp
		pop	di
		pop	si
		ret				; Return far

;========================================
;		_videogchar		;
;========================================
; Obtiene caracter y atributo en la posicion del cursor
_videogchar:
		push	si
		push	di
		push	bp
		mov	bp,sp
		mov	ah,8		; Funcion 8
		mov	bh,[bp+0Ah]	; Pagina activa
		int	10h		; Interrupcion de video, obtiene
					; el caracter (al) y atributo (ah)
		pop	bp
		pop	di
		pop	si
		ret			; Return far

;========================================
;		_videogcmode		;
;========================================
; Obtiene localizacion y modo del cursor.
_videogcmode:
		push	si
		push	di
		mov	ah,3		; Funcion 3
		int	10h		; Interrupcion de Video, obtiene
					; renglon y columna del cursor(dh,dl)
					; Tipo de cursor actual (ch,cl)
		mov	ax,cx		; Regresa modo del cursor
		pop	di
		pop	si
		ret			; Return far

;========================================
;		_videogcols		;
;========================================
; Obtiene el numero de caracteres en la pantalla
_videogcols:
		push	si
		push	di
		mov	ah,0Fh		; Funcion 15
		int	10h		; Interrupcion de Video, Obtiene 
					; estado , al=modo, bh=pagina
					; ah= numero de caracteres.
		mov	al,ah
		xor	ah,ah		; ah=00
		pop	di
		pop	si
		ret			; Return far

;========================================
;		_videogcursor		;
;========================================
; Regresa posicion y tipo del cursor en la pagina indicada
_videogcursor:
		push	si
		push	di
		push	bp
		mov	bp,sp
		mov	ah,3		; Funcion 3
		mov	bh,[bp+0Ah]	; Pagina
		int	10h		; Interrupcion de Video, Obtiene 
					; posicion en dx, modo en cx
		mov	ax,dx		; Regresa posicion del cursor
		pop	bp
		pop	di
		pop	si
		ret			; Return far

;========================================
;		_videogdot		;
;========================================
; Obtiene el color del pixel indicado
_videogdot:
		push	si
		push	di
		push	bp
		mov	bp,sp
		mov	ah,0Dh		; Funcion 13
		mov	dx,[bp+0Ah]	; Renglon
		mov	cx,[bp+0Ch]	; Columna
		int	10h		; Interrupcion de Video, obtiene
					; al= color del pixel
		xor	ah,ah		; ah=0
		pop	bp
		pop	di
		pop	si
		ret			; Return far

;========================================
;		_videogmode		;
;========================================
; Obtiene el modo de video
_videogmode:
		push	si
		push	di
		mov	ah,0Fh		; Funcion 15
		int	10h		; Interrupcion de Video, obtiene
					; al=modo, bh=pagina
		xor	ah,ah		; ah=00
		pop	di
		pop	si
		ret			; Return far

;========================================
;		_videogpage		;
;========================================
; Obtiene la pagina activa
_videogpage:
		push	si
		push	di
		mov	ah,0Fh		; Funcion 15
		int	10h		; Interrupcion de Video, obtiene
					; al=modo, bh=pagina
		mov	al,bh		; Regresa la pagina
		xor	ah,ah		; ah=00
		pop	di
		pop	si
		ret			; Return far

;========================================
;		_videogpen		;
;========================================
; Obtiene posicion de la pluma de luz
_videogpen:
		push	si
		push	di
		push	bp
		mov	bp,sp
		mov	ah,4		; Funcion 4
		int	10h		; Interrupcion de Video, obtiene
					; dx=posicion de la pluma
		mov	di,[bp+0Ah]
		mov	[di],dh
		mov	[di+1],dl
		mov	[di+2],ch
		mov	[di+3],bx
		mov	al,ah
		xor	ah,ah		; ah=00
		pop	bp
		pop	di
		pop	si
		ret			; Return far

;========================================
;		_videomode		;
;========================================
; Coloca modo de video
_videomode:
		push	si
		push	di
		push	bp
		mov	bp,sp
		mov	ah,0		; Funcion 0
		mov	al,[bp+0Ah]	; al= modo
		int	10h		; Interrupcion de Video, coloca el
					; modo segun (al)
		pop	bp
		pop	di
		pop	si
		ret			; Return far

;========================================
;		_videopage		;
;========================================
; Coloca la pagina activa
_videopage:
		push	si
		push	di
		push	bp
		mov	bp,sp
		mov	ah,5		; Funcion 5
		mov	al,[bp+0Ah]	; al= pagina
		int	10h		; Interrupcion de Video, coloca la
					; pagina activa segun (al)
		pop	bp
		pop	di
		pop	si
		ret			; Return far

;========================================
;		_videopalette		;
;========================================
; Coloca el color de la paleta
_videopalette:
		push	si
		push	di
		push	bp
		mov	bp,sp
		mov	ah,0Bh		; Funcion 11
		mov	bh,1		; bh=1, cambiar paleta
		mov	bl,[bp+0Ah]	; bl=1 GR/RED/YEL,bl=1 CYAN/MAG/WHITE
		int	10h		; Interrupcion de Video, Coloca el
					; color segun bx (modo CGA)
		pop	bp
		pop	di
		pop	si
		ret			; Return far

;========================================
;		_videoputc		;
;========================================
; Escribe un caracter avanzando el cursor
_videoputc:
		push	si
		push	di
		push	bp
		mov	bp,sp
		mov	ah,0Eh		; Funcion 14
		mov	al,[bp+0Ah]	; Caracter a escribir
		mov	bl,[bp+0Ch]	; Color del caracter (modo grafico)
		int	10h		; Interrupcion de video, escribe el
					; caracter en al, modo teletypo
		pop	bp
		pop	di
		pop	si
		ret			; Return far

;========================================
;		_videoscroll		;
;========================================
; Enrolla una ventana en la pagina activa.
_videoscroll:
		push	si
		push	di
		push	bp
		mov	bp,sp
		cmp	word ptr [bp+12h],0	; Direccion de enrollado
		jle	loc_10			; Salta si < or =
		mov	ah,6		; Funcion 6, enrolla hacia arriba
		jmp	short loc_11	; (0227)
loc_10:
		mov	ax,[bp+12h]
		neg	ax
		mov	[bp+12h],ax
		mov	ah,7		; Funcion 7, enrolla hacia abajo
loc_11:
		mov	al,[bp+12h]	; Numero de lineas
		mov	ch,[bp+0Ah]	; (ch,cl)= (renglon,columna) esquina
		mov	cl,[bp+0Ch]	;          superior izquierda
		mov	dh,[bp+0Eh]	; (dh,dl)= (renglon,columna) esquina
		mov	dl,[bp+10h]	;	   inferior derecha
		mov	bh,[bp+14h]	; Atributo, para las lineas en blanco
		int	10h		; Interrupcion de video, Enrolla la
					;  ventana, al=lineas
		pop	bp
		pop	di
		pop	si
		ret			; Return far

 
include endpseg.h		; Declaraciones de segmentos 
		end
