
/* sero.h				      */
/* integration of a system of two ordinary    */
/* linear differential equations	      */
/* Harold V. McIntosh, 6 April 1975	      */
/* November 14, 1983 - SMU - Gerardo Cisneros */
/* November 23, 1991 - adapted for C	      */
/* December 22, 1992 - adapted for NeXt	      */



void serzm(double *u);
void serum(double *u);
void sercy(double *u, double *x);
void serip(double *z, double *x, double *y);
void sermp(double *z, double *x, double *y);
void serms(double x, double y, int l, int m);
double serar(double e, void EV(), void RK());
double serav(double e, void EV(), void RK());
void serne(double w[][9], int n);
void serau(double *u, double *x, double f, double *y);
void serpot(double d, double e, void po());
void serr4(double *x, double *z, double d, double e, void EV());
void serri4(double *x, double *z, double d, double e, void EV());
void serr6(double *x, double *z, double d, double e, void EV());
void seruc(double w[][9], double e, void PO(), void RK());
void sertj(double w[][9], int n, double *x0, double z0, double dz, double e, void EV(), void RK());
void serdt(double w[][9], int n, double *x0, double z0, double dz, double e, void PO(), void RK());
void potl1(double *u, double e, double z);
void potl2(double *u, double e, double z);
void potl3(double *u, double e, double z);
void potl4(double *u, double e, double z);
void potl5(double *u, double e, double z);
void potl6(double *u, double e, double z);
void potl7(double *u, double e, double z);
void potl8(double *u, double e, double z);
void potl9(double *u, double e, double z);
void potl10(double *u, double e, double z);
void potl11(double *u, double e, double z);
void potl12(double *u, double e, double z);
void potl13(double *u, double e, double z);
void potl14(double *u, double e, double z);

/* end sero.h */
