
/* TRI.C				*/
/* Harold V. McIntosh, 01 November 1972 */
/* 1 November 1993 - "C" version	*/

# import <math.h>
# import "tri.h"


double trdb[TDM][TDB];			          /* diagonal band	*/
double trdm[TDM][TDM];			 	  /* dynamical matrix	*/
double trnm[TDM][TDM];				  /* normal modes	*/
double trpl[8]={1.0,0.1,0.1,0.1,0.1,0.1,0.1,0.1}; /* parameter list	*/


/* generate the tridiagonal band for uniform interactions */
void tridb(db,f) double db[TDM][TDB], f; {int i;
for (i=0; i<TDM; i++) {db[i][0]=f; db[i][1]=-2.0*f; db[i][2]=f;}
}

/* zero dynamical matrix */
void trizdm(z) double z[TDM][TDM]; {int i, j;
for (i=0; i<TDM; i++) for (j=0; j<TDM; j++) z[i][j]=0.0;
}

