/*									*/
/*	VIDEOH.H:	Function prototypes				*/
/*									*/
/*	By :  Saturnino Julio De La Trinidad H.				*/
/*									*/
/*	Departamento de Aplicacion de Microcomputadoras			*/
/*	Instituto de Ciencias de la Universidad Autonoma de Puebla	*/
/*									*/

#if __STDC__
#define _Cdecl
#else
#define _Cdecl	cdecl
#endif

#if     !defined(__WIZARD_DEF_)
#define __WIZARD_DEF_

 void far _Cdecl  videobackground(int color);
 void far _Cdecl  videocattr(int page, char byte, char attr, int count);
 void far _Cdecl  videochar(int page, char byte, int count);
 void far _Cdecl  videocmode(int startrow, int endrow);
 void far _Cdecl  videocursor(int page, int row, int column);
 void far _Cdecl  videodot(int pixelrow, int pixelcolumn, int color);
 void far _Cdecl  videomode(int mode);
 void far _Cdecl  videopage(int page);
 void far _Cdecl  videopalette(int colorset);
 void far _Cdecl  videoputc(char byte, int color);
 void far _Cdecl  videoscroll(int ulrow, int ulcol, int lrrow, int lrcol,
                                                       int lines, int attr);
 int  far _Cdecl  videogchar(int page);
 int  far _Cdecl  videogcmode(void);
 int  far _Cdecl  videogcols(void);
 int  far _Cdecl  videogcursor(int page);
 int  far _Cdecl  videogdot(int pixelrow, int pixelcolumn);
 int  far _Cdecl  videogmode(void);
 int  far _Cdecl  videogpage(void);


 struct pen {
	char		charrow;
	char		charcolumn;
	unsigned char	pixelrow;
	unsigned char	pixelcolumn;
	};

 int  far _Cdecl  videogpen(struct pen *penv);

 #endif
